<template>
	<main class="mt-36">
		<h2 class="contents-title">Form</h2>
		<form action="">
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Text Input</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="text"
						name="text"
						placeholder="Text"
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">
					Full Width Input
				</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input form-input--block"
						type="text"
						name="fullwidth"
						placeholder="Full Width Input"
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Password Input</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="password"
						name="password"
						placeholder="Password"
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Email Address</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="email"
						name="email"
						placeholder="Email"
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Number Input</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="number"
						name="number"
						placeholder="Number"
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">
					Single File Input (Full Width)
				</div>
				<div class="bzg_c flex" data-col="s12,m8,l8">
					<div class="form-group--label-input">
						<input
							class="form-input js-file-input"
							id="singleFile"
							type="file"
							name="file"
						/>
					</div>
					<label for="singleFile">
						<div class="btn--primary ml-4">Browse</div></label
					>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">
					Multiple File Input
				</div>
				<div class="bzg_c flex" data-col="s12,m8,l8">
					<div class="form-group--label-input">
						<input
							class="form-input js-file-input"
							id="multiFile"
							type="file"
							name="file"
						/>
					</div>
					<label for="multiFile">
						<div class="btn--primary ml-4">Browse</div></label
					>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Textarea Input</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<textarea
						class="form-input"
						name="textarea"
						placeholder="Text Area"
					></textarea>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Disabled Input</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="text"
						name="disabled"
						placeholder="Disabled"
						disabled
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Read-only Input</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="text"
						name="readonly"
						placeholder="Read-only"
						readonly
					/>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Dropdown Select</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<select class="form-input" name="dropdown">
						<option value="1">Option 1</option>
						<option value="2">Option 2</option>
						<option value="3">Option 3</option>
					</select>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Radio Buttons</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<div class="form-check-group">
						<label class="form-check__item" for="rbOption1"
							><input id="rbOption1" type="radio" name="radio" /> Option
							1</label
						>
						<label class="form-check__item" for="rbOption2"
							><input id="rbOption2" type="radio" name="radio" /> Option
							2</label
						>
						<label class="form-check__item" for="rbOption3"
							><input id="rbOption3" type="radio" name="radio" /> Option
							3</label
						>
					</div>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Checkbox</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<div class="form-check-group">
						<label class="form-check__item" for="cbOption1"
							><input id="cbOption1" type="checkbox" name="checkbox" checked />
							Option 1</label
						>
						<label class="form-check__item" for="cbOption2"
							><input id="cbOption2" type="checkbox" name="checkbox" /> Option
							2</label
						>
						<label class="form-check__item" for="cbOption3"
							><input id="cbOption3" type="checkbox" name="checkbox" checked />
							Option 3</label
						>
					</div>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c" data-col="s12,m8,l8" data-offset="m4,l4">
					<button class="btn btn--primary" type="submit">Submit</button>
					<button class="btn btn--ghost-secondary" type="reset">Cancel</button>
				</div>
			</div>
		</form>
		<Code :codeText="form" />
		<hr />
		<h2 class="contents-title">Form Validator</h2>
		<form @submit.prevent="submitForm" class="js-validate">
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Username</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						v-model.trim="$v.formData.username.$model"
						type="text"
						name="username"
						placeholder="Username"
						id="username"
						@blur="$v.formData.username.$touch()"
					/>
					<span
						v-show="
							!$v.formData.username.required && $v.formData.username.$dirty
						"
						>This field is required.</span
					>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Email</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<input
						class="form-input"
						type="email"
						name="email"
						placeholder="Email"
						v-model.trim="$v.formData.email.$model"
						@blur="$v.formData.email.$touch()"
					/>
					<span v-show="!$v.formData.email.required && $v.formData.email.$dirty"
						>Invalid email address.</span
					>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Birthdate</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<date-picker
						type="date"
						placeholder="Birthdate"
						v-model.trim="$v.formData.birthday.$model"
						@blur="$v.formData.birthday.$touch()"
					></date-picker>
					<span
						v-show="
							!$v.formData.birthday.required && $v.formData.birthday.$dirty
						"
						>This field is required.</span
					>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Gender</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<div class="form-check-group">
						<label class="form-check__item" for="gender1"
							><input
								id="gender1"
								type="radio"
								name="gender"
								value="male"
								class="form-input--check"
								v-model.trim="$v.formData.gender.$model"
								@blur="$v.formData.gender.$touch()"
							/>
							<span
								:class="
									!$v.formData.gender.required && $v.formData.gender.$dirty
										? 'color-red'
										: ''
								"
								>Male</span
							></label
						>

						<label class="form-check__item" for="gender2"
							><input
								id="gender2"
								type="radio"
								name="gender"
								value="female"
								class="form-input--check"
								v-model.trim="$v.formData.gender.$model"
								@blur="$v.formData.gender.$touch()"
							/>
							<span
								:class="
									!$v.formData.gender.required && $v.formData.gender.$dirty
										? 'color-red'
										: ''
								"
								>Female</span
							></label
						>
						<span v-show="!$v.formData.gender && $v.formData.gender.$dirty"
							>This field is required.</span
						>
					</div>
				</div>
			</div>
			<div class="bzg mb-24">
				<div class="bzg_c form-label" data-col="s12,m4,l4">Hobbies</div>
				<div class="bzg_c" data-col="s12,m8,l8">
					<div class="form-check-group form-input--block">
						<label class="form-check__item display-block" for="hobby1"
							><input
								id="hobby1"
								type="checkbox"
								name="hobby"
								class="form-input--check"
								v-model.trim="$v.formData.hobbies.reading.$model"
								@blur="$v.formData.hobbies.reading.$touch()"
							/>
							<span
								:class="
									!$v.formData.hobbies.reading.required &&
									$v.formData.hobbies.reading.$dirty
										? 'color-red'
										: ''
								"
								>Reading</span
							></label
						>
						<label class="form-check__item display-block" for="hobby2"
							><input
								id="hobby2"
								type="checkbox"
								name="hobby"
								class="form-input--check"
								v-model.trim="$v.formData.hobbies.writing.$model"
								@blur="$v.formData.hobbies.writing.$touch()"
							/>
							<span
								:class="
									!$v.formData.hobbies.writing.required &&
									$v.formData.hobbies.writing.$dirty
										? 'color-red'
										: ''
								"
								>Writing</span
							></label
						>
						<label class="form-check__item display-block" for="hobby3"
							><input
								id="hobby3"
								type="checkbox"
								name="hobby"
								class="form-input--check"
								v-model.trim="$v.formData.hobbies.running.$model"
								@blur="$v.formData.hobbies.running.$touch()"
							/>
							<span
								:class="
									!$v.formData.hobbies.running.required &&
									$v.formData.hobbies.running.$dirty
										? 'color-red'
										: ''
								"
								>Running</span
							></label
						>
						<label class="form-check__item display-block" for="hobby4"
							><input
								id="hobby4"
								type="checkbox"
								name="hobby"
								class="form-input--check"
								v-model.trim="$v.formData.hobbies.swimming.$model"
								@blur="$v.formData.hobbies.swimming.$touch()"
							/>
							<span
								:class="
									!$v.formData.hobbies.swimming.required &&
									$v.formData.hobbies.swimming.$dirty
										? 'color-red'
										: ''
								"
								>Swimming</span
							></label
						>
					</div>
				</div>
			</div>
			<div class="bzg mb-12">
				<div class="bzg_c" data-col="s12,m8,l8" data-offset="m4,l4">
					<button class="btn btn--primary" type="submit">Submit</button>
				</div>
			</div>
		</form>
		<Code :codeText="formValidator" />
		<ContentFooter />
	</main>
</template>

<script>
// import { validate } from 'json-schema'
import DatePicker from 'vue2-datepicker'
import 'vue2-datepicker/index.css'
import { required, email } from 'vuelidate/lib/validators'

export default {
	components: { DatePicker },
	validations: {
		formData: {
			username: { required },
			email: { email },
			birthday: { required },
			gender: { required },
			hobbies: {
				reading: { required },
				writing: { required },
				running: { required },
				swimming: { required }
			}
		}
	},
	methods: {
		submitForm() {
			this.$v.$touch()
			if (!this.$v.invalid) {
				console.log('valid')
			} else {
				console.log('error')
			}
		}
	},
	data() {
		return {
			formData: {
				username: null,
				email: null,
				birthday: null,
				gender: null,
				hobbies: {
					reading: null,
					writing: null,
					running: null,
					swimming: null
				}
			},
			form: `<form action="">
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Text Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input" type="text" name="text" placeholder="Text"></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Full Width Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input form-input--block" type="text" name="fullwidth" placeholder="Full Width Input"></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Password Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input" type="password" name="password" placeholder="Password"></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Email Address</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input" type="email" name="email" placeholder="Email"></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Number Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input" type="number" name="number" placeholder="Number"></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Single File Input (Full Width)</div>
        <div class="bzg_c" data-col="s12,m8,l8">
            <input class="form-input js-file-input" id="singleFile" type="file" name="file">
            <label class="flex form-file-label" for="singleFile">
                <div class="js-file-name form-file-input form-input--block"> </div>
                <div class="btn--primary ml-4">Browse</div>
            </label>
        </div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Multiple File Input</div>
        <div class="bzg_c" data-col="s12,m8,l8">
            <input class="form-input js-file-input" id="multipleFile" type="file" name="file" multiple>
            <label class="flex form-file-label" for="multipleFile">
                    <div class="js-file-name form-file-input"> </div>
                    <div class="btn--primary ml-4">Browse</div>
            </label>
        </div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Textarea Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><textarea class="form-input" name="textarea" placeholder="Text Area"></textarea></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Disabled Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input" type="text" name="disabled" placeholder="Disabled" disabled></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Read-only Input</div>
        <div class="bzg_c" data-col="s12,m8,l8"><input class="form-input" type="text" name="readonly" placeholder="Read-only" readonly></div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Dropdown Select</div>
        <div class="bzg_c" data-col="s12,m8,l8">
            <select class="form-input" name="dropdown">
                <option value="1">Option 1</option>
                <option value="2">Option 2</option>
                <option value="3">Option 3</option>
            </select>
        </div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Radio Buttons</div>
        <div class="bzg_c" data-col="s12,m8,l8">
            <div class="form-check-group">
                <label class="form-check__item" for="rbOption1"><input id="rbOption1" type="radio" name="radio"> Option 1</label>
                <label class="form-check__item" for="rbOption2"><input id="rbOption2" type="radio" name="radio"> Option 2</label>
                <label class="form-check__item" for="rbOption3"><input id="rbOption3" type="radio" name="radio"> Option 3</label>
            </div>
        </div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c form-label" data-col="s12,m4,l4">Checkbox</div>
        <div class="bzg_c" data-col="s12,m8,l8">
            <div class="form-check-group">
                <label class="form-check__item" for="cbOption1"><input id="cbOption1" type="checkbox" name="checkbox" checked> Option 1</label>
                <label class="form-check__item" for="cbOption2"><input id="cbOption2" type="checkbox" name="checkbox"> Option 2</label>
                <label class="form-check__item" for="cbOption3"><input id="cbOption3" type="checkbox" name="checkbox" checked> Option 3</label>
            </div>
        </div>
    </div>
    <div class="bzg mb-12">
        <div class="bzg_c" data-col="s12,m8,l8" data-offset="m4,l4">
            <button class="btn btn--primary" type="submit">Submit</button>
            <button class="btn btn--ghost-secondary" type="reset">Cancel</button>
        </div>
    </div>
</form>`,
			formValidator: `<form action="" class="js-validate">
<div class="bzg mb-12">
    <div class="bzg_c form-label" data-col="s12,m4,l4">Username</div>
    <div class="bzg_c" data-col="s12,m8,l8">
        <input class="form-input" type="text" name="username" placeholder="Username" required>
    </div>
</div>
<div class="bzg mb-12">
    <div class="bzg_c form-label" data-col="s12,m4,l4">Email</div>
    <div class="bzg_c" data-col="s12,m8,l8">
        <input class="form-input" type="email" name="email" placeholder="Email" required>
    </div>
</div>
<div class="bzg mb-12">
    <div class="bzg_c form-label" data-col="s12,m4,l4">Birthdate</div>
    <div class="bzg_c" data-col="s12,m8,l8">
        <input class="form-input datepicker-here js-date" type="text" name="birthdate" placeholder="Birthdate" required>
    </div>
</div>
<div class="bzg mb-12">
    <div class="bzg_c form-label" data-col="s12,m4,l4">Gender</div>
    <div class="bzg_c" data-col="s12,m8,l8">
        <div class="form-check-group">
            <label class="form-check__item" for="gender1"><input id="gender1" type="radio" name="gender" required> Male</label>
            <label class="form-check__item" for="gender2"><input id="gender2" type="radio" name="gender"> Female</label>
        </div>
    </div>
</div>
<div class="bzg mb-24">
    <div class="bzg_c form-label" data-col="s12,m4,l4">Hobbies</div>
    <div class="bzg_c" data-col="s12,m8,l8">
        <div class="form-check-group form-input--block">
            <label class="form-check__item" for="hobby1"><input id="hobby1" type="checkbox" name="hobby" required> Reading</label>
            <label class="form-check__item" for="hobby2"><input id="hobby2" type="checkbox" name="hobby"> Writing</label>
            <label class="form-check__item" for="hobby3"><input id="hobby3" type="checkbox" name="hobby"> Running</label>
            <label class="form-check__item" for="hobby4" data-invalid="Custom Error Message"><input id="hobby4" type="checkbox" name="hobby"> Swimming</label>
        </div>
    </div>
</div>
<div class="bzg mb-12">
    <div class="bzg_c" data-col="s12,m8,l8" data-offset="m4,l4">
        <button class="btn btn--primary" type="submit">Submit</button>
    </div>
</div>
</form>`
		}
	}
}
</script>

<style lang="scss" scoped>
main {
	color: $text;
	width: 100%;
}

.color-red {
	color: red;
}

.display-block {
	display: block;
}
</style>
